; load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_code.ncl"
; load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_csm.ncl"
; load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/contributed.ncl"
;
load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/shea_util.ncl"
;****************************************************************************
begin
;****************************************************************************
; input data for box plots 
;****************************************************************************
  sic_box = new((/3,5/),"float",-999.99)      ; 1979-2014/PI/PI+Forced
  sst_box = new((/3,5/),"float",-999.99)      

  sic_box(0,0) = -1.506                       ; 1979-2014 
  sic_box(0,1) = -0.495
  sic_box(0,2) = -0.369
  sic_box(0,3) = -0.241
  sic_box(0,4) = 0.152

  sic_box(1,0) = -1.026                       ; PI 
  sic_box(1,1) = -0.120
  sic_box(1,2) = 0.009
  sic_box(1,3) = 0.118
  sic_box(1,4) = 0.832

  sic_box(2,0) = -1.894                       ; PI + 1979-2014 forced
  sic_box(2,1) = -0.615
  sic_box(2,2) = -0.437
  sic_box(2,3) = -0.304
  sic_box(2,4) = 0.526

;******************************************************************
  p29_sic_box = new((/3,5/),"float",-999.99)  ; 1950-1978/PI/PI+Forced
  p29_sst_box = new((/3,5/),"float",-999.99)

  p29_sic_box(0,0) = -0.773                   ; 1950-1978
  p29_sic_box(0,1) = -0.223
  p29_sic_box(0,2) = -0.089
  p29_sic_box(0,3) = 0.050
  p29_sic_box(0,4) = 0.517

  p29_sic_box(1,0) = -1.163                   ; PI
  p29_sic_box(1,1) = -0.148
  p29_sic_box(1,2) = 0.009
  p29_sic_box(1,3) = 0.152
  p29_sic_box(1,4) = 0.983

  p29_sic_box(2,0) = -1.191                   ; PI + 1950-1978 forced
  p29_sic_box(2,1) = -0.221
  p29_sic_box(2,2) = -0.066
  p29_sic_box(2,3) = 0.094
  p29_sic_box(2,4) = 0.955

;******************************************************************
  sst_box(0,0) = -0.047                      ; 1979-2014 
  sst_box(0,1) = 0.055 
  sst_box(0,2) = 0.080
  sst_box(0,3) = 0.101
  sst_box(0,4) = 0.259

  sst_box(1,0) = -0.144                      ; PI
  sst_box(1,1) = -0.023 
  sst_box(1,2) = -0.001 
  sst_box(1,3) = 0.023 
  sst_box(1,4) = 0.181 

  sst_box(2,0) = -0.107                      ; PI + 1979-2014 forced 
  sst_box(2,1) = 0.063 
  sst_box(2,2) = 0.088 
  sst_box(2,3) = 0.114 
  sst_box(2,4) = 0.314 

;******************************************************************
  p29_sst_box(0,0) = -0.143                 ; 1950-1978
  p29_sst_box(0,1) = -0.016 
  p29_sst_box(0,2) = 0.016
  p29_sst_box(0,3) = 0.040
  p29_sst_box(0,4) = 0.165

  p29_sst_box(1,0) = -0.191                 ; PI
  p29_sst_box(1,1) = -0.029
  p29_sst_box(1,2) = -0.001
  p29_sst_box(1,3) = 0.029
  p29_sst_box(1,4) = 0.222

  p29_sst_box(2,0) = -0.192                 ; PI + 1950-1978 forced
  p29_sst_box(2,1) = -0.020
  p29_sst_box(2,2) = 0.011
  p29_sst_box(2,3) = 0.039
  p29_sst_box(2,4) = 0.212

;****************************************************************************
  x = (/1.,3.,5./)
  x1 = x + 0.4
  x2 = x - 0.4 

;****************************************************************************
; input data for timeseries plots 
;****************************************************************************
  nmon = 71
  ncol = 15

  dummy = asciiread("fig1.sie.txt",(/nmon,ncol/),"float")    ; SIE
  dummy@_FillValue = -999.99

  temp = new( (/14,nmon/),typeof(dummy),dummy@_FillValue)

  t_x = dummy(:,0)
  do icase=0,ncol-2
     temp(icase,:)=dummy(:,icase+1)
  end do

  dummy_sst = asciiread("fig1.sst.txt",(/nmon,ncol/),"float") ; SST
  dummy_sst@_FillValue = -999.99

  sst = new( (/14,nmon/),typeof(dummy_sst),dummy_sst@_FillValue)

  do icase=0,ncol-2
     sst(icase,:)=dummy_sst(:,icase+1)
  end do

;****************************************************************************
; create plot
;****************************************************************************
  wks = gsn_open_wks("X11","fig1")               

  res = True         

  res@vpHeightF                  = 0.2
  res@vpWidthF                   = 0.36

  res@trYMinF                    = -2.
  res@trYMaxF                    = 1.
  res@trXMinF                    = -0.5 
  res@trXMaxF                    = 6.5 

  res@tmYLMode                   = "Explicit"
  res@tmYLValues                 = (/-2.,-1.5,-1.0,-0.5,0.,0.5,1.0/)
  res@tmYLLabels                 = (/"-2.0","-1.5","-1.0","-0.5","0.0","0.5","1.0"/)

  res@tmXBMode                   = "Explicit" 
  res@tmXBValues                 = (/-1.,1.,3.,5./)
  res@tmXBLabels                 = (/"Hist","PI","PI + Forced"/)

  res@tmYLMinorOn                = False
  res@tmYRBorderOn               = True
  res@tmXTBorderOn               = True

  res@tmXBLabelFontHeightF       = 0.016
  res@tmYLLabelFontHeightF       = 0.014
  res@tiYAxisFontHeightF         = 0.016
  res@tiYAxisString              = "Trend (10~S~6~N~ km~S~2~N~ decade~S~-1~N~)"

  res@tmXBMajorLengthF           = -0.01
  res@tmXBMajorOutwardLengthF    = -0.01
  res@tmYLMajorLengthF           = -0.01
  res@tmYLMajorOutwardLengthF    = -0.01

  res@tiMainFontHeightF          = 0.017
  res@tiMainString               = "Sea Ice Extent Trend"

;****************************************************************************
  res_v2 = res

  delete(res_v2@tmYLValues)
  delete(res_v2@tmYLLabels)

  res_v2@trYMinF                 = -0.2
  res_v2@trYMaxF                 = 0.4
  res_v2@tmYLValues              = (/-0.2,-0.1,0.,0.1,0.2,0.3,0.4/)
  res_v2@tmYLLabels              = (/"-0.2","-0.1","0.0","0.1","0.2","0.3","0.4"/)
  res_v2@tiMainString            = "SST Trend"
  res_v2@tiYAxisString           = "Trend (~S~o~N~C decade~S~-1~N~)"

;****************************************************************************
  res_v3 = res

  res_v3@tmYLMinorOn             = False
  res_v3@tmYLBorderOn            = False 
  res_v3@tmYRMinorOn             = False
  res_v3@tmYRBorderOn            = False 
  res_v3@tmXBMinorOn             = False
  res_v3@tmXBBorderOn            = False 
  res_v3@tmXTMinorOn             = False
  res_v3@tmXTBorderOn            = False 

  res_v3@tiMainString            = ""
  res_v3@tiYAxisString           = ""

  res_v3@tmXBMajorLengthF        = 0. 
  res_v3@tmXBMajorOutwardLengthF = 0.
  res_v3@tmYLMajorLengthF        = 0.
  res_v3@tmYLMajorOutwardLengthF = 0.

  res_v3@tmYLLabels              = (/"","","","","","",""/)
  res_v3@tmXBLabels              = (/"","",""/)

;****************************************************************************
  res_v4 = res_v2

  res_v4@tmYLMinorOn             = False
  res_v4@tmYLBorderOn            = False
  res_v4@tmYRMinorOn             = False
  res_v4@tmYRBorderOn            = False
  res_v4@tmXBMinorOn             = False
  res_v4@tmXBBorderOn            = False
  res_v4@tmXTMinorOn             = False
  res_v4@tmXTBorderOn            = False

  res_v4@tiMainString            = ""
  res_v4@tiYAxisString           = ""

  res_v4@tmXBMajorLengthF        = 0.
  res_v4@tmXBMajorOutwardLengthF = 0.
  res_v4@tmYLMajorLengthF        = 0.
  res_v4@tmYLMajorOutwardLengthF = 0.

  res_v4@tmYLLabels              = (/"","","","","","",""/)
  res_v4@tmXBLabels              = (/"","",""/)

;************************************************************************
; resources for polylines that draws the boxes
;************************************************************************
  llres                          = True			
  llres@gsLineThicknessF         = 3
;************************************************************************
; resources that control color and width of boxes
;************************************************************************
  opti                           = True		
  opti@boxWidth                  = 0.7
  opti@boxColors                 = (/"blue4","blue4","blue4"/)
;************************************************************************
  opti_p29 = opti 		
  opti_p29@boxColors             = (/"yellowgreen","yellowgreen","yellowgreen"/)
;************************************************************************

  vres = True  
  vres@gsnDraw                   = False 
  vres@gsnFrame                  = False       

  vres@vpHeightF                 = 0.26
  vres@vpWidthF                  = 0.84

  vres@trYMinF                   = -2.
  vres@trYMaxF                   = 3.
  vres@trXMinF                   = 1950. 
  vres@trXMaxF                   = 2020.

  vres@tmXBMode                  = "Explicit"
  vres@tmXBValues                = (/1950,1960,1970,1980,1990,2000,2010,2020/)
  vres@tmXBLabels                = "" + vres@tmXBValues

  vres@tmYLMode                  = "Explicit"
  vres@tmYLValues                = (/-2.,-1.,0.,1.,2.,3./)
  vres@tmYLLabels                = (/"-2.0","-1.0","0.0","1.0","2.0","3.0"/)

  vres@gsnLeftString             = "" 
  vres@gsnLeftStringFontHeightF  = 0.017

  vres@tiYAxisFontHeightF        = 0.016
  vres@tiXAxisFontHeightF        = 0.016
  vres@tmXBLabelFontHeightF      = 0.015
  vres@tmXTLabelFontHeightF      = 0.015
  vres@tmYLLabelFontHeightF      = 0.015
  vres@tmYRLabelFontHeightF      = 0.015

  vres@tmXTOn                    = "False"
  vres@tmYROn                    = "False"
  vres@tmYRLabelsOn              = "True"
  vres@tmXTLabelsOn              = "False"
  vres@gsnYRefLine               = 0.0
  vres@gsnYRefLineDashPattern    = 1
  vres@gsnYRefLineThicknessF     = 0.5

  vres@xyMarkLineModes           = (/"Lines","Lines","Lines","Markers","Lines","Lines","Lines","Lines","Lines","Lines"/)
  vres@xyMarkers                 = (/16,16,16,16,16,16,16,16,16,16/)
  vres@xyMarkerColor             = "red"
  vres@xyMarkerSizeF             = 0.01

  vres@xyMonoLineColor           = False  
  vres@xyLineColors              = (/"red","red","red","red","blue4","green4","tan4","darkorchid1","black","orange1"/) 
  vres@xyLineThicknesses         = (/2,2,2,2,2,2,2,2,2,2/)      
  vres@xyDashPatterns            = (/0,2,4,0,0,0,0,0,0,0/)     

  vres@tiYAxisString             = "SIE Anomaly (10~S~6~N~ km~S~2~N~)" 

  vres@tmXBMajorLengthF          = 0.01
  vres@tmXBMajorOutwardLengthF   = 0.01
  vres@tmYLMajorLengthF          = 0.01
  vres@tmYLMajorOutwardLengthF   = 0.01

  vres1 = vres
  vres2 = vres

;****************************************************************************
  tres  = vres

  tres@trYMinF                   = -0.6
  tres@trYMaxF                   = 0.4

  tres@tmYLValues                = (/-0.6,-0.4,-0.2,0.,0.2,0.4/)
  tres@tmYLLabels                = (/"-0.6","-0.4","-0.2","0.0","0.2","0.4"/)

  tres@xyMarkLineModes           = (/"Lines","Lines","Lines","Lines","Lines","Lines","Lines","Lines","Lines","Lines"/)

  tres@xyLineColors              = (/"red","red","red","red","blue4","green4","tan4","darkorchid1","black","orange1"/) 
  tres@xyLineThicknesses         = (/2,2,2,2,2,2,2,2,2,2/)    
  tres@xyDashPatterns            = (/0,2,4,12,0,0,0,0,0,0/)  

  tres@tiYAxisString             = "Temperature Anomaly (~S~o~N~C)"
  tres@trYReverse                = True

  tres1 = tres
  tres2 = tres

;****************************************************************************
  vres@pmLegendDisplayMode       = "Always"
  vres@pmLegendSide              = "Top"
  vres@pmLegendParallelPosF      = 0.78
  vres@pmLegendOrthogonalPosF    = -0.58

  vres@pmLegendWidthF            = 0.08
  vres@pmLegendHeightF           = 0.11
  vres@lgLabelFontHeightF        = 0.0075
  vres@lgOrientation             = "vertical"
  vres@lgPerimOn                 = False
  vres@lgItemOrder               = (/9,8,7,6,5,4,3,2,1,0/)

  vres@xyExplicitLegendLabels    = (/"  NSIDC G02135","  NSIDC 0192 ","  NSIDC G00917","  Nimbus-1 Sep 1964","  CanESM2","  CESM1","  CanESM5 P1","  CanESM5 P2","  CESM2","  NorCPM1"/)

;****************************************************************************
  tres@pmLegendDisplayMode       = "Always"
  tres@pmLegendSide              = "Top"
  tres@pmLegendParallelPosF      = 0.15
  tres@pmLegendOrthogonalPosF    = -1.114

  tres@pmLegendWidthF            = 0.08
  tres@pmLegendHeightF           = 0.11
  tres@lgLabelFontHeightF        = 0.0075
  tres@lgOrientation             = "vertical"
  tres@lgPerimOn                 = False
  tres@lgItemOrder               = (/9,8,7,6,5,4,3,2,1,0/)

  tres@xyExplicitLegendLabels    = (/"  ERSST","  HadISST","  COBE","  ERA5","  CanESM2","  CESM1","  CanESM5 P1","  CanESM5 P2","  CESM2","  NorCPM1"/)

;****************************************************************************
; Panel (a)
;****************************************************************************

  res@vpXF                       = 0.1
  res@vpYF                       = 0.95

  xy = boxplot(wks,x1,sic_box,opti,res,llres)	
 
  plres                          = True
  plres@gsLineColor              = "red"
  plres@gsLineThicknessF         = 3.0
  plres@gsLineDashPattern        = 0 

  plres2                         = True
  plres2@gsLineColor             = "red"
  plres2@gsLineThicknessF        = 2.0
  plres2@gsLineDashPattern       = 2 

  plx  = (/-1,21/)
  ply  = (/0.2231248,0.2231248/)  ; observed SIE trend

  dum1 = gsn_add_polyline(wks, xy, plx, ply, plres) 

  ply  = (/0.1359677,0.1359677/)  ; oberved SIE trend
  dum2 = gsn_add_polyline(wks, xy, plx, ply, plres2) 

  ply  = (/0.3102818,0.3102818/)  ; oberved SIE trend
  dum3 = gsn_add_polyline(wks, xy, plx, ply, plres2) 

  xy_p29 = boxplot(wks,x2,p29_sic_box,opti_p29,res_v3,llres)	
  overlay(xy,xy_p29)

;****************************************************************************
; Panel (b)
;****************************************************************************

  res_v2@vpXF                   = 0.583
  res_v2@vpYF                   = 0.95
  res_v2@trYReverse             = True

  cd = boxplot(wks,x1,sst_box,opti,res_v2,llres)	

  ply  = (/-0.066615,-0.066615/)   ; observed SST trend for 1979-2014
  dum4 = gsn_add_polyline(wks, cd, plx, ply, plres) 

  ply  = (/-0.0886326,-0.0886326/) ; obseved SST trend 
  dum5 = gsn_add_polyline(wks, cd, plx, ply, plres2) 

  ply  = (/-0.0421582,-0.0421582/) ; observed sst trend 
  dum6 = gsn_add_polyline(wks, cd, plx, ply, plres2) 

  plres@gsLineColor            = "orange1"
  plres2@gsLineColor           = "orange1"

  ply  = (/0.06576,0.06576/)       ; observed SST trend for 1950-1978
  dum7 = gsn_add_polyline(wks, cd, plx, ply, plres) 

  ply  = (/0.0306,0.0306/)         ; observed SST trend
  dum8 = gsn_add_polyline(wks, cd, plx, ply, plres2) 

  ply  = (/0.122174,0.122174/)     ; observed SST trend
  dum9 = gsn_add_polyline(wks, cd, plx, ply, plres2) 

  cd_p29 = boxplot(wks,x2,p29_sst_box,opti_p29,res_v4,llres)	
  overlay(cd,cd_p29)

;****************************************************************************
; Panel (c)
;****************************************************************************

  vres@vpXF                   = 0.1
  vres@vpYF                   = 0.67

  plotA = gsn_csm_xy (wks,t_x,temp(0:9,:),vres)    

  vres1@pmLegendDisplayMode   = "NoCreate" 
  delete(vres1@xyLineColors)
  vres1@gsnXYFillColors       = "grey88"
  vres1@xyLineColor           = -1              
  vres1@gsnXYFillOpacityF     = 0.35
  plotB = gsn_csm_xy (wks,t_x,temp(10:11,:),vres1) 

  overlay(plotA,plotB)

  vres1@gsnLeftString         = "Time series of SIE over the period of 1950-2020"
  vres1@gsnXYFillColors       = "grey"
  vres1@xyLineColor           = -1         
  vres1@gsnXYFillOpacityF     = 0.35
  plotC  = gsn_csm_xy (wks,t_x,temp(12:13,:),vres1) 

  overlay(plotA,plotC)

;****************************************************************************
; Panel (d)
;****************************************************************************

  tres@vpXF                   = 0.1
  tres@vpYF                   = 0.325

  plotS = gsn_csm_xy (wks,t_x,sst(0:9,:),tres) 

  tres1@pmLegendDisplayMode   = "NoCreate"  
  delete(tres1@xyLineColors)
  tres1@gsnXYFillColors       = "grey88"
  tres1@xyLineColor           = -1  
  tres1@gsnXYFillOpacityF     = 0.35
  plotT = gsn_csm_xy (wks,t_x,sst(10:11,:),tres1) 

  overlay(plotS,plotT)

  tres1@gsnLeftString         = "Time series of SST over the period of 1950-2020"
  tres1@gsnXYFillColors       = "grey"
  tres1@xyLineColor           = -1        
  tres1@gsnXYFillOpacityF     = 0.35
  plotU = gsn_csm_xy (wks,t_x,sst(12:13,:),tres1)  

  overlay(plotS,plotU)

;***************************************************************************
  txres = True
  txres@txFontHeightF = 0.02
  txres@txFont        = 22

  gsn_text_ndc(wks,"a",0.01,0.985,txres)
  gsn_text_ndc(wks,"b",0.495,0.985,txres)
  gsn_text_ndc(wks,"c",0.01,0.69,txres)
  gsn_text_ndc(wks,"d",0.01,0.348,txres)

;***************************************************************************
   resP = True   
   resP@gsnPanelXWhiteSpacePercent = 5

   maximize_output(wks,resP)
end
