; load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_code.ncl"
; load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_csm.ncl"
; load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/contributed.ncl"
;*****************************************************************************
begin
;*****************************************************************************
; input data for panel (a)
;*****************************************************************************

  nmon = 13 
  ncol = 9 

  dummy = asciiread("fig2.sie_trend.txt",(/nmon,ncol/),"float") 
  dummy@_FillValue = -999.99

  temp = new( (/8,nmon/),typeof(dummy),dummy@_FillValue)

  x = dummy(:,0)
  do icase=0,ncol-2
     temp(icase,:)=dummy(:,icase+1)
  end do

;*****************************************************************************
; input data for scatter plots 
;*****************************************************************************

  nyrs = 391
  nvar = 8
  
  dummy_scatter = asciiread("fig2.scatter.txt",(/nyrs,nvar/),"float")
  dummy_scatter@_FillValue = -999.99

  tas = new( (/8,nyrs/),typeof(dummy_scatter),dummy_scatter@_FillValue)

  do icase=0,nvar-1
     tas(icase,:)=dummy_scatter(:,icase)
  end do

;*****************************************************************************
; create plots
;*****************************************************************************
  wks = gsn_open_wks("X11","fig2")             

  vres                          = True  
  vres@gsnDraw                  = False 
  vres@gsnFrame                 = False

  vres@vpHeightF                = 0.32
  vres@vpWidthF                 = 0.56

  vres@trYMinF                  = -0.8
  vres@trYMaxF                  = 0.4
  vres@trXMinF                  = 2008. 
  vres@trXMaxF                  = 2020.

  vres@tmXBMode                 = "Explicit"
  vres@tmXBValues               = (/2008,2010,2012,2014,2016,2018,2020/)
  vres@tmXBLabels               = "" + vres@tmXBValues

  vres@tmYLMode                 = "Explicit"
  vres@tmYLValues               = (/-0.8,-0.6,-0.4,-0.2,0.,0.2,0.4/)
  vres@tmYLLabels               = (/"-0.8","-0.6","-0.4","-0.2","0.0","0.2","0.4"/) 

  vres@gsnLeftString            = ""  
  vres@gsnLeftStringFontHeightF = 0.015

  vres@tiYAxisFontHeightF       = 0.015
  vres@tiXAxisFontHeightF       = 0.015
  vres@tmXBLabelFontHeightF     = 0.013
  vres@tmXTLabelFontHeightF     = 0.013
  vres@tmYLLabelFontHeightF     = 0.013
  vres@tmYRLabelFontHeightF     = 0.013

  vres@tmXTOn                   = "False"
  vres@tmYRLabelsOn             = "True"
  vres@tmXTLabelsOn             = "False"
  vres@gsnYRefLine              = 0.0
  vres@gsnYRefLineDashPattern   = 1
  vres@gsnYRefLineThicknessF    = 0.5 

  vres@xyMarkLineModes          = (/"Lines","Lines"/)
  vres@xyMarkers                = (/16,16/)
  vres@xyMarkerColor            = "black"
  vres@xyMarkerSizeF            = 0.016

  vres@xyMonoLineColor          = False 
  vres@xyLineColors             = (/"red","blue4"/)
  vres@xyLineThicknesses        = (/3,3/)
  vres@xyDashPatterns           = (/0,0/)

  vres@tiYAxisString            = "SIE Trend (10~S~6~N~ km~S~2~N~ decade~S~-1~N~)"    
  vres@tiXAxisString            = "End Year"      

  vres@tmXBMajorLengthF         = 0.01
  vres@tmXBMajorOutwardLengthF  = 0.01
  vres@tmYLMajorLengthF         = 0.01
  vres@tmYLMajorOutwardLengthF  = 0.01

  vres1 = vres
  vres2 = vres

;**********************************************************************
  vres@pmLegendDisplayMode      = "Always"
  vres@pmLegendSide             = "Top"
  vres@pmLegendParallelPosF     = 0.8
  vres@pmLegendOrthogonalPosF   = -1.

  vres@pmLegendWidthF           = 0.06
  vres@pmLegendHeightF          = 0.05
  vres@lgLabelFontHeightF       = 0.012
  vres@lgOrientation            = "vertical"
  vres@lgPerimOn                = False
  vres@lgItemOrder              = (/1,0/)

  vres@xyExplicitLegendLabels   = (/"  OBS","  GCM"/)

;**********************************************************************
  qres                          = True    
  qres@gsnDraw                  = False  
  qres@gsnFrame                 = False 

  qres@vpHeightF                = 0.26 
  qres@vpWidthF                 = 0.32

  qres@trYMinF                  = -1.6 
  qres@trYMaxF                  = 0.4 
  qres@trXMinF                  = 0.05 
  qres@trXMaxF                  = 0.55

  qres@tmXBMode                 = "Explicit"
  qres@tmXBValues               = (/0.1,0.2,0.3,0.4,0.5/)
  qres@tmXBLabels               = "" + qres@tmXBValues

  qres@tmYLMode                 = "Explicit"
  qres@tmYLValues               = (/-1.6,-1.2,-0.8,-0.4,0.,0.4/)
  qres@tmYLLabels               = "" + qres@tmYLValues

  qres@gsnLeftString            = ""  
  qres@gsnLeftStringFontHeightF = 0.015

  qres@tiYAxisFontHeightF       = 0.015
  qres@tiXAxisFontHeightF       = 0.015
  qres@tmXBLabelFontHeightF     = 0.013
  qres@tmXTLabelFontHeightF     = 0.013
  qres@tmYLLabelFontHeightF     = 0.013
  qres@tmYRLabelFontHeightF     = 0.013

  qres@tmXTOn                   = "False"
  qres@tmYROn                   = "False"
  qres@tmYRLabelsOn             = "False"
  qres@tmXTLabelsOn             = "False"
  qres@gsnYRefLine              = 0.
  qres@gsnYRefLineThicknessF    = 1.
  qres@gsnYRefLineDashPattern   = 6
  qres@gsnXRefLine              = 0.
  qres@gsnXRefLineThicknessF    = 1.
  qres@gsnXRefLineDashPattern   = 6

  qres@xyMarkLineModes          = (/"Markers","Markers","Markers"/)
  qres@xyMarkers                = (/16,16,16/);16/)
  qres@xyMarkerColors           = (/"red","red","red"/)
  qres@xyMarkerSizeF            = 0.012

  qres@tiXAxisString            = "GMST Trend (K decade~S~-1~N~)" 
  qres@tiYAxisString            = "SIE Trend (10~S~6~N~ km~S~2~N~ decade~S~-1~N~)"     

  qres@tmXBMajorLengthF         = 0.01
  qres@tmXBMajorOutwardLengthF  = 0.01
  qres@tmYLMajorLengthF         = 0.01
  qres@tmYLMajorOutwardLengthF  = 0.01

;**********************************************************************
; Panel (a)
;**********************************************************************
  vres@vpXF                    = 0.22
  vres@vpYF                    = 0.92

  plotA = gsn_csm_xy (wks,x,temp(0:1,:),vres)  

  vres1@pmLegendDisplayMode    = "NoCreate"  
  delete(vres1@xyLineColors)
  vres1@gsnXYFillColors        = "royalblue1"
  vres1@xyLineColor            = -1                
  vres1@gsnXYFillOpacityF      = 0.6
  plotB  = gsn_csm_xy (wks,x,temp(4:5,:),vres1) 

  overlay(plotA,plotB)

  vres1@pmLegendDisplayMode    = "NoCreate"    
  vres1@gsnXYFillColors        = "blue2"
  vres1@xyLineColor            = -1
  plotC = gsn_csm_xy (wks,x,temp(6:7,:),vres1) 

  overlay(plotA,plotC)

  vres1@pmLegendDisplayMode    = "NoCreate"  
  vres1@gsnLeftString          = "SIE Trend"
  vres1@gsnXYFillColors        = "LightPink"
  vres1@xyLineColor            = -1    
  vres1@gsnXYFillOpacityF      = 0.25
  plotD = gsn_csm_xy (wks,x,temp(2:3,:),vres1) 

  overlay(plotA,plotD)

;**********************************************************************
; Panel (b)
;**********************************************************************
  qres@vpXF                    = 0.12
  qres@vpYF                    = 0.48

  plotJ1 = gsn_csm_xy (wks,tas(0,:),tas(1,:),qres)

  qres@xyMarkerColors          = (/"blue4","blue4","blue4"/)
  qres@xyMarkerSizeF           = 0.0045

  qres@gsnLeftString           = "1979-2014"  
  plotJ2 = gsn_csm_xy (wks,tas(2,:),tas(3,:),qres)
  overlay(plotJ1,plotJ2)

;**********************************************************************
; Panel (c)
;**********************************************************************
  qres@vpXF                    = 0.56
  qres@vpYF                    = 0.48

  qres@xyMarkerColors          = (/"red","red","red"/)
  qres@xyMarkerSizeF           = 0.012

  qres@gsnLeftString           = "" 
  plotK1 = gsn_csm_xy (wks,tas(4,:),tas(5,:),qres)

  qres@xyMarkerColors          = (/"blue4","blue4","blue4"/)
  qres@xyMarkerSizeF           = 0.0045

  qres@gsnLeftString           = "1979-2020" 
  plotK2 = gsn_csm_xy (wks,tas(6,:),tas(7,:),qres)
  overlay(plotK1,plotK2)

;************************************************************************
  txres = True
  txres@txFontHeightF = 0.02
  txres@txFont = 22

  gsn_text_ndc(wks,"a",0.138,0.945,txres)
  gsn_text_ndc(wks,"b",0.04,0.505,txres)
  gsn_text_ndc(wks,"c",0.478,0.505,txres)

;************************************************************************
  resP = True  
  resP@gsnPanelXWhiteSpacePercent = 5

  maximize_output(wks,resP)
end
