; load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_code.ncl"
; load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/gsn_csm.ncl"
; load "$NCARG_ROOT/lib/ncarg/nclscripts/csm/contributed.ncl"
;******************************************************************************
begin
;******************************************************************************
; SIC and SST
;******************************************************************************
  filename1 = "fig5.sic.sst.bin"

  ey = 89 
  ex = 180 

  amv_sic = new((/ey,ex/), "float")
  amv_sic_sig = new((/ey,ex/), "float")
  amv_sst = new((/ey,ex/), "float")
  amv_sst_sig = new((/ey,ex/), "float")

  ipo_sic = new((/ey,ex/), "float")
  ipo_sic_sig = new((/ey,ex/), "float")
  ipo_sst = new((/ey,ex/), "float")
  ipo_sst_sig = new((/ey,ex/), "float")

  dims_amv_sic = (/ey,ex/)

  amv_sic(:,:) = fbindirread(filename1, 0, dims_amv_sic, "float")
  amv_sic_sig(:,:) = fbindirread(filename1, 1, dims_amv_sic, "float")
  amv_sst(:,:) = fbindirread(filename1, 2, dims_amv_sic, "float")
  amv_sst_sig(:,:) = fbindirread(filename1, 3, dims_amv_sic, "float")

  ipo_sic(:,:) = fbindirread(filename1, 4, dims_amv_sic, "float")
  ipo_sic_sig(:,:) = fbindirread(filename1, 5, dims_amv_sic, "float")
  ipo_sst(:,:) = fbindirread(filename1, 6, dims_amv_sic, "float")
  ipo_sst_sig(:,:) = fbindirread(filename1, 7, dims_amv_sic, "float")

  amv_sic!0="lat"
  amv_sic!1="lon"

  amv_sic&lat = fspan(-88,88,ey)
  amv_sic&lon = fspan(0,358,ex)
  amv_sic&lat@units = "degrees_north"
  amv_sic&lon@units = "degrees_east"

  amv_sic@_FillValue = -999.99
  amv_sic_sig@_FillValue = -999.99
  amv_sst@_FillValue = -999.99
  amv_sst_sig@_FillValue = -999.99

  ipo_sic@_FillValue = -999.99
  ipo_sic_sig@_FillValue = -999.99
  ipo_sst@_FillValue = -999.99
  ipo_sst_sig@_FillValue = -999.99

  copy_VarCoords(amv_sic,amv_sic_sig)
  copy_VarCoords(amv_sic,amv_sst)
  copy_VarCoords(amv_sic,amv_sst_sig)
  copy_VarCoords(amv_sic,ipo_sic)
  copy_VarCoords(amv_sic,ipo_sic_sig)
  copy_VarCoords(amv_sic,ipo_sst)
  copy_VarCoords(amv_sic,ipo_sst_sig)

;*****************************************************************************
; PSL, Wind and Geopotential Height
;*****************************************************************************
  filename2 = "fig5.psl.wind.z300.bin"

  ny = 143
  nx = 144 

  amv_psl = new((/ny,nx/), "float")    
  amv_psl_sig = new((/ny,nx/), "float")    
  amv_uas = new((/ny,nx/), "float")    
  amv_uas_sig = new((/ny,nx/), "float")    
  amv_vas = new((/ny,nx/), "float")    
  amv_vas_sig = new((/ny,nx/), "float")    
  amv_z300 = new((/ny,nx/), "float")    
  amv_z300_sig = new((/ny,nx/), "float")    

  ipo_psl = new((/ny,nx/), "float")    
  ipo_psl_sig = new((/ny,nx/), "float")    
  ipo_uas = new((/ny,nx/), "float")    
  ipo_uas_sig = new((/ny,nx/), "float")    
  ipo_vas = new((/ny,nx/), "float")    
  ipo_vas_sig = new((/ny,nx/), "float")    
  ipo_z300 = new((/ny,nx/), "float")    
  ipo_z300_sig = new((/ny,nx/), "float")    

  dims = (/ny,nx/)

  amv_psl(:,:) = fbindirread(filename2, 0, dims, "float")
  amv_psl_sig(:,:) = fbindirread(filename2, 1, dims, "float")
  amv_uas(:,:) = fbindirread(filename2, 2, dims, "float")
  amv_uas_sig(:,:) = fbindirread(filename2, 3, dims, "float")
  amv_vas(:,:) = fbindirread(filename2, 4, dims, "float")
  amv_vas_sig(:,:) = fbindirread(filename2, 5, dims, "float")
  amv_z300(:,:) = fbindirread(filename2, 6, dims, "float")
  amv_z300_sig(:,:) = fbindirread(filename2, 7, dims, "float")

  ipo_psl(:,:) = fbindirread(filename2, 8, dims, "float")
  ipo_psl_sig(:,:) = fbindirread(filename2, 9, dims, "float")
  ipo_uas(:,:) = fbindirread(filename2, 10, dims, "float")
  ipo_uas_sig(:,:) = fbindirread(filename2, 11, dims, "float")
  ipo_vas(:,:) = fbindirread(filename2, 12, dims, "float")
  ipo_vas_sig(:,:) = fbindirread(filename2, 13, dims, "float")
  ipo_z300(:,:) = fbindirread(filename2, 14, dims, "float")
  ipo_z300_sig(:,:) = fbindirread(filename2, 15, dims, "float")

  amv_psl!0="lat"
  amv_psl!1="lon"

  amv_psl&lat = fspan(-90.,90.,ny)
  amv_psl&lon = fspan(0.,357.5,nx)
  amv_psl&lat@units = "degrees_north"
  amv_psl&lon@units = "degrees_east"

  amv_psl@_FillValue = -999.99
  amv_psl_sig@_FillValue = -999.99
  amv_uas@_FillValue = -999.99
  amv_uas_sig@_FillValue = -999.99
  amv_vas@_FillValue = -999.99
  amv_vas_sig@_FillValue = -999.99
  amv_z300@_FillValue = -999.99
  amv_z300_sig@_FillValue = -999.99

  ipo_psl@_FillValue = -999.99
  ipo_psl_sig@_FillValue = -999.99
  ipo_uas@_FillValue = -999.99
  ipo_uas_sig@_FillValue = -999.99
  ipo_vas@_FillValue = -999.99
  ipo_vas_sig@_FillValue = -999.99
  ipo_z300@_FillValue = -999.99
  ipo_z300_sig@_FillValue = -999.99

  copy_VarCoords(amv_psl,amv_psl_sig)
  copy_VarCoords(amv_psl,amv_uas)
  copy_VarCoords(amv_psl,amv_uas_sig)
  copy_VarCoords(amv_psl,amv_vas)
  copy_VarCoords(amv_psl,amv_vas_sig)
  copy_VarCoords(amv_psl,amv_z300)
  copy_VarCoords(amv_psl,amv_z300_sig)

  copy_VarCoords(amv_psl,ipo_psl)
  copy_VarCoords(amv_psl,ipo_psl_sig)
  copy_VarCoords(amv_psl,ipo_uas)
  copy_VarCoords(amv_psl,ipo_uas_sig)
  copy_VarCoords(amv_psl,ipo_vas)
  copy_VarCoords(amv_psl,ipo_vas_sig)
  copy_VarCoords(amv_psl,ipo_z300)
  copy_VarCoords(amv_psl,ipo_z300_sig)

;****************************************************************************
  wks = gsn_open_wks("X11","fig5") 

  res = True
  res@gsnDraw                       = False  
  res@gsnFrame                      = False 

  res@vpHeightF                     = 0.3  
  res@vpWidthF                      = 0.4 

  res@cnFillOn                      = True  
  res@cnFillPalette                 = "BlueDarkRed18"
  res@cnLinesOn                     = False  
  res@cnLineLabelsOn                = False 
  res@gsnLeftString                 = "(b) Southern Ocean Temperature" 
  res@gsnRightString                = " "       
  res@gsnLeftStringFontHeightF      = 0.013
  res@mpFillOn                      = False    
  res@cnLevelSelectionMode          = "ExplicitLevels"
  res@cnLevels                      = (/-0.3,-0.25,-0.2,-0.15,-0.1,-0.05,0,0.05,0.1,0.15,0.2,0.25,0.3/)
  res@mpMaxLatF                     = 60.
  res@mpMinLatF                     = -90.
  res@mpCenterLonF                  = 180.
  res@mpMinLonF                     = 0.
  res@mpMaxLonF                     = 360.
  res@gsnMajorLatSpacing            = 30
  res@gsnMajorLonSpacing            = 60
  res@tmXBMode                      = "Explicit"
  res@tmYLMode                      = "Explicit"
  res@tmXBLabelFontHeightF          = 0.011
  res@tmYLLabelFontHeightF          = 0.011
  res@lbLabelBarOn                  = True 
  res@tmXBMinorOn                   = False
  res@tmYLMinorOn                   = False
  res@tmXTOn                        = False
  res@tmYROn                        = False

  res@tmXBMajorLengthF              = 0.008
  res@tmXBMajorOutwardLengthF       = 0.008
  res@tmYLMajorLengthF              = 0.008
  res@tmYLMajorOutwardLengthF       = 0.008

  res@lbOrientation                 = "horizontal" 
  res@pmLabelBarWidthF              = 0.3         
  res@pmLabelBarHeightF             = 0.03
  res@lbLabelFontHeightF            = 0.01
  res@lbTitleOn                     = True 
  res@lbTitleString                 = "~S~o~N~C"
  res@lbTitleFontHeightF            = 0.012
  res@pmLabelBarOrthogonalPosF      = 0.2
  res@lbLabelStride                 = 2

;******************************************************************************
  res2 = True
  res2@gsnDraw                      = False
  res2@gsnFrame                     = False

  res2@cnLevelSelectionMode         = "ManualLevels"
  res2@cnMinLevelValF               = -300.
  res2@cnMaxLevelValF               = 300.
  res2@cnLevelSpacingF              = 10.
  res2@cnInfoLabelOn                = False
  res2@cnLinesOn                    = False
  res2@cnLineLabelsOn               = False
  res2@cnFillScaleF                 = 0.5

  res3 = res2
  res3@cnMinLevelValF               = 0.
  res3@cnMaxLevelValF               = 100.
  res3@cnLevelSpacingF              = 1.
  res3@cnFillScaleF                 = 0.3

;******************************************************************************
  vres = res

  delete(vres@pmLabelBarOrthogonalPosF)
  vres@cnFillPalette                = "precip_diff_12lev"
  vres@cnFillMode                   = "RasterFill"
  vres@cnLevels                     = (/-6.,-5.,-4.,-3.,-2.,-1.,0.,1.,2.,3.,4.,5.,6./)
  vres@mpMaxLatF                    = -50.
  vres@gsnMajorLatSpacing           = 20

  vres@lbTitleString                = "%"
  vres@pmLabelBarOrthogonalPosF     = 0.75

;******************************************************************************
  qres = res

  qres@cnLevels                     = (/-60.,-50.,-40.,-30.,-20.,-10.,0.,10.,20.,30.,40.,50.,60./)

  qres@lbTitleString                = "Pa"

;******************************************************************************
  cres = True 

  cres@gsnDraw                      = False  
  cres@gsnFrame                     = False 

  cres@gsnLeftString                = ""
  cres@cnFillOn                     = False   
  cres@cnLinesOn                    = True        
  cres@cnLineLabelsOn               = True       
  cres@cnInfoLabelOn                = False
  cres@cnLineLabelFontHeightF       = 0.008
  cres@cnLevelSelectionMode         = "ManualLevels" 
  cres@cnMinLevelValF               = -21.                   
  cres@cnMaxLevelValF               = 21.                   
  cres@cnLevelSpacingF              = 3.                   

  cres@gsnContourZeroLineThicknessF = 1
  cres@gsnContourNegLineDashPattern = 1
  cres@gsnContourPosLineDashPattern = 0

;******************************************************************************
  bres = cres

  bres@cnMinLevelValF               = -10.  
  bres@cnMaxLevelValF               = 10.  
  bres@cnLevelSpacingF              = 2.  

;******************************************************************************
  res_vc = True
 
  res_vc@gsnDraw                    = False  
  res_vc@gsnFrame                   = False 

  res_vc@vpHeightF                  = 0.3  
  res_vc@vpWidthF                   = 0.4 

  res_vc@vcGlyphStyle               = "FillArrow"
  res_vc@vcLineArrowThicknessF      = 1
  res_vc@vcMinDistanceF             = 0.008
  res_vc@vcRefLengthF               = 0.05
  res_vc@vcFillArrowFillColor       = "green3"

  res_vc@vcRefAnnoOn                = True
  res_vc@vcRefMagnitudeF            = 0.3 
  res_vc@vcRefAnnoString1           = "0.3 m s~S~-1~N~"
  res_vc@vcRefAnnoFontHeightF       = 0.0095
  res_vc@vcRefAnnoSide              = "Top"
  res_vc@vcRefAnnoString2On         = False
  res_vc@vcRefAnnoPerimOn           = False
  res_vc@vcRefAnnoOrthogonalPosF    = -1.65;-1.6;-1.45
  res_vc@vcRefAnnoParallelPosF      = 0.999
  res_vc@vcRefAnnoBackgroundColor   = "white"
  res_vc@vcVectorDrawOrder          = "PostDraw"
  res_vc@gsnLeftString              = ""

;******************************************************************************
; panel (a)
;******************************************************************************
  vres@vpXF                         = 0.08
  vres@vpYF                         = 0.95

  vres@cnLevels                     = (/-1.2,-1.,-0.8,-0.6,-0.4,-0.2,0.,0.2,0.4,0.6,0.8,1.,1.2/)
  vres@gsnLeftString                = "SIC response to AMV phase transition" 

  plotA1 = gsn_csm_contour_map(wks,amv_sic(:,:),vres)
  plotA2 = gsn_csm_contour(wks,amv_sic_sig(:,:),res2)

  opt = True
  opt@gsnShadeFillType = "pattern"
  opt@gsnShadeHigh = 17
  opt@gsnShadeFillDotSizeF = 0.0015

  plotA2 = gsn_contour_shade(plotA2,10.,11.,opt)
  overlay(plotA1,plotA2)

;******************************************************************************
; panel (d)
;******************************************************************************
  vres@vpXF                         = 0.55
  vres@vpYF                         = 0.95

  vres@cnLevels                     = (/-6.,-5.,-4.,-3.,-2.,-1.,0.,1.,2.,3.,4.,5.,6./)
  vres@gsnLeftString                = "SIC response to IPO phase transition" 

  plotB1 = gsn_csm_contour_map(wks,ipo_sic(:,:),vres)
  plotB2 = gsn_csm_contour(wks,ipo_sic_sig(:,:),res2)
  plotB2 = gsn_contour_shade(plotB2,-800.,-799.,opt)
  overlay(plotB1,plotB2)

;******************************************************************************
; panel (b)
;******************************************************************************
  res@vpXF                          = 0.08
  res@vpYF                          = 0.73

  res@gsnLeftString                 = "SST response to AMV phase transition" 
  plotC1 = gsn_csm_contour_map(wks,amv_sst(:,:),res)
  plotC2 = gsn_csm_contour(wks,amv_sst_sig(:,:),res2)
  plotC2 = gsn_contour_shade(plotC2,-800.,-799.,opt)
  overlay(plotC1,plotC2)

;******************************************************************************
; panel (e)
;******************************************************************************
  res@vpXF                          = 0.55
  res@vpYF                          = 0.73

  res@cnLevels                      = (/-0.6,-0.5,-0.4,-0.3,-0.2,-0.1,0.,0.1,0.2,0.3,0.4,0.5,0.6/)
  res@gsnLeftString                 = "SST response to IPO phase transition" 

  plotD1 = gsn_csm_contour_map(wks,ipo_sst(:,:),res)
  plotD2 = gsn_csm_contour(wks,ipo_sst_sig(:,:),res2)
  plotD2 = gsn_contour_shade(plotD2,-800.,-799.,opt)
  overlay(plotD1,plotD2)

;******************************************************************************
; panel (c)
;******************************************************************************
  qres@vpXF                         = 0.08
  qres@vpYF                         = 0.45

  qres@gsnLeftString                = "SLP/Wind/GPH response to AMV phase transition"

  plotE1 = gsn_csm_contour_map(wks,amv_psl(:,:),qres)
  plotE3 = gsn_csm_vector(wks,amv_uas_sig(:,:),amv_vas_sig(:,:),res_vc)
  overlay(plotE1,plotE3)

  plotE2 = gsn_csm_contour(wks,amv_psl_sig(:,:),res2)
  plotE2 = gsn_contour_shade(plotE2,-800.,-799.,opt)
  overlay(plotE1,plotE2)

  plotE4 = gsn_csm_contour(wks,amv_z300_sig(:,:),bres)
  overlay(plotE1,plotE4)

;******************************************************************************
; panel (f)
;******************************************************************************
  qres@vpXF                         = 0.55
  qres@vpYF                         = 0.45

  qres@cnLevels                     = (/-150.,-125.,-100.,-75.,-50.,-25.,0.,25.,50.,75.,100.,125.,150./)
  qres@gsnLeftString                = "SLP/Wind/GPH response to IPO phase transition"

  res_vc@vcRefMagnitudeF            = 0.8 
  res_vc@vcRefAnnoString1           = "0.8 m s~S~-1~N~"

  plotF1 = gsn_csm_contour_map(wks,ipo_psl(:,:),qres)
  plotF3 = gsn_csm_vector(wks,ipo_uas_sig(:,:),ipo_vas_sig(:,:),res_vc)
  overlay(plotF1,plotF3)

  plotF2 = gsn_csm_contour(wks,ipo_psl_sig(:,:),res2)
  plotF2 = gsn_contour_shade(plotF2,-800.,-799.,opt)
  overlay(plotF1,plotF2)

  plotF4 = gsn_csm_contour(wks,ipo_z300_sig(:,:),cres)
  overlay(plotF1,plotF4)

;******************************************************************************
  txres = True
  txres@txFontHeightF = 0.018
  txres@txFont = 22

  gsn_text_ndc(wks,"a",0.04,0.84,txres)
  gsn_text_ndc(wks,"b",0.04,0.69,txres)
  gsn_text_ndc(wks,"c",0.04,0.408,txres)
  gsn_text_ndc(wks,"d",0.51,0.84,txres)
  gsn_text_ndc(wks,"e",0.51,0.69,txres)
  gsn_text_ndc(wks,"f",0.51,0.408,txres)

;******************************************************************************
  resP = True

  maximize_output(wks,resP)
end
